base-4.7.0.2: Basic libraries

Copyright | (c) The University of Glasgow 2001
License | BSD-style (see the file libraries/base/LICENSE)
Maintainer | libraries@haskell.org
Stability | experimental
Portability | portable
Safe Haskell | Trustworthy
Language | Haskell2010

Data.Bool

Contents

- Booleans
  - Operations

Description

The `Bool` type and related functions.

Synopsis

- data Bool :: *
  - = False
  - | True
- (&&) :: Bool -> Bool -> Bool
- (||) :: Bool -> Bool -> Bool
- not :: Bool -> Bool
- otherwise :: Bool
- bool :: a -> a -> Bool -> a

# Booleans

data Bool :: * Source

Constructors

False |
True |

Instances

Bounded Bool |
Enum Bool |
Eq Bool |
Data Bool |
Ord Bool |
Read Bool |
Show Bool |
Ix Bool |
Generic Bool |
Typeable Bool |
FiniteBits Bool |
Bits Bool |
Storable Bool |
Typeable * Bool |
type Rep Bool |
type (==) Bool a b |

## Operations

(&&) :: Bool -> Bool -> Bool infixr 3 Source

Boolean "and"

(||) :: Bool -> Bool -> Bool infixr 2 Source

Boolean "or"

not :: Bool -> Bool Source

Boolean "not"

otherwise :: Bool

`otherwise` is defined as the value `True`. It helps to make guards more readable. eg.

     f x | x < 0     = ...
         | otherwise = ...

bool :: a -> a -> Bool -> a

Case analysis for the `Bool` type. `bool a b p` evaluates to `a` when `p` is `False`, and evaluates to `b` when `p` is `True`.

Since: 4.7.0.0